.486
.model flat, stdcall
option casemap :none
include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc

include \masm32\macros\macros.asm
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib

_dwtoa proto :DWORD,:DWORD

printv MACRO varname:VARARG
    FOR arg,<varname>
        invoke StdOut,reparg(arg)
    ENDM
ENDM

; Set to 1 for all values in range.
STEP = 123456
.data
    buffer1     db 14 dup(0)
    buffer2     db 14 dup(0)
    testValue   dd 7fffffffh
    testValue2   dd -1
    errorCount  dd 0
    testCount   dd 0
.code
start:

    ; Added memfill because bad values left trash in buffer.
    invoke _dwtoa,0,addr buffer1    
    printv SADD("0 = "),addr buffer1,SADD(13,10)
    ;invoke memfill,addr buffer1,14,0
    
    invoke _dwtoa,1,addr buffer1    
    printv SADD("1 = "),addr buffer1,SADD(13,10)
    ;invoke memfill,addr buffer1,14,0
    
    invoke _dwtoa,-1,addr buffer1    
    printv SADD("-1 = "),addr buffer1,SADD(13,10)
    ;invoke memfill,addr buffer1,14,0
    
    invoke _dwtoa,2147483647,addr buffer1    
    printv SADD("2147483647 = "),addr buffer1,SADD(13,10)
    ;invoke memfill,addr buffer1,14,0
    
    invoke _dwtoa,-2147483648,addr buffer1    
    printv SADD("-2147483648 = "),addr buffer1,SADD(13,10)
    ;invoke memfill,addr buffer1,14,0

    printv SADD("Press any key to test positive values")
    call getc
    ;exit

; This loop tests the range of positive values.
runLoop:
    inc testCount
    invoke _dwtoa,testValue,addr buffer1
    invoke dw2a,testValue,addr buffer2
    invoke lnstr,addr buffer1
    push eax
    invoke lnstr,addr buffer2
    pop edx
    cmp eax,edx
    je  @F   
    inc errorCount
    jmp doLoop
@@:    
    invoke cmpsi,addr buffer1,addr buffer2,edx
    or  eax,eax
    jz  doLoop
    inc errorCount
doLoop:
    sub testValue,STEP
    
    invoke _dwtoa,testValue,addr buffer1
    printv addr buffer1,SADD(13,10)

    mov eax,testValue
    invoke dw2a,eax,addr buffer2
    printv addr buffer2,SADD(13,10,13,10)

    cmp testValue,0
    jle @F    
    jmp runLoop
@@:
    invoke dw2a,errorCount,addr buffer2
    printv SADD("error count = "),addr buffer2,SADD(13,10)
    invoke dw2a,testCount,addr buffer2
    printv SADD("test count = "),addr buffer2,SADD(13,10)
    ;exit

    printv SADD("Press any key to test negative values")
    call getc
    
; This loop tests the range of negative values
runLoop2:
    inc testCount
    invoke _dwtoa,testValue2,addr buffer1
    mov eax,testValue2
    neg eax
    invoke dw2a,eax,addr buffer2    
    invoke lnstr,addr buffer1+1
    push eax
    invoke lnstr,addr buffer2
    pop edx
    cmp eax,edx
    je  @F
    inc errorCount
    jmp doLoop2
@@:
    invoke cmpsi,addr buffer1+1,addr buffer2,edx
    or  eax,eax
    jz  doLoop2
    inc errorCount
    
doLoop2:
    sub testValue2,STEP
    
    invoke _dwtoa,testValue2,addr buffer1
    printv addr buffer1+1,SADD(13,10)
    
    mov eax,testValue2
    neg eax
    invoke dw2a,eax,addr buffer2
    printv addr buffer2,SADD(13,10,13,10)
    
    cmp testValue2,0
    jg  @F
    jmp runLoop2
@@:
    invoke dw2a,errorCount,addr buffer2
    printv SADD("error count = "),addr buffer2,SADD(13,10)
    invoke dw2a,testCount,addr buffer2
    printv SADD("test count = "),addr buffer2,SADD(13,10)

    printv SADD("Press any key to exit")
    call getc
    exit

; #########################################################################

_dwtoa proc dwValue:DWORD, lpBuffer:DWORD
    LOCAL absnum :DWORD
    
    push ebx
    push esi
    push edi
    mov eax,dwValue
    mov esi,lpBuffer
    
    k4 = 429497             ;2^32/10000  rounded up
    k9 = 2814749768         ;2^43/5^5 = 2814749767.28
    
    mov ecx,k9              ;prepare to fast div by 100000

    test eax,-1             ;is number negative?
    jns skip                ;no, just leave it
    neg eax                 ;yes, make it positive
    mov byte ptr [esi],"-"  ;put sign in place
    inc esi                 ;leave room for sign
skip:
    mov absnum,eax          ;save absolute value of number    
    ;#####fast div by 100000
    mul ecx                 ;div 100000
    mov ecx,100000          ;prepare to multiply up the top 5 digits
    shr edx,16              ;shift top 5 digits into place    edx=12345
    mov eax,edx             ;copy to eax to multiply up to real size again
    mov edi,edx             ;save a copy of top 5 digits
    mul ecx                 ;eax=1234500000
    sub eax,absnum          ;subtract orignal number
    neg eax                 ;need to reverse the subtract
                            ;eax is now the low 5 digits
    ;##end fast div

    mov ecx,k4              ;about to do div 10000 by reciprocal multiply
    mov ebx,10              ;useful constant
    xchg edi,eax            ;swap top 5 and bottom 5 digits

    ;####################part 1
    mul ecx                 ;div top 5 digits by 10000
    jc digit1               ;if digit is not zero then process it,
                            ;else try next digit
    mul ebx                 ;multiply by 10 to get next digit into edx
    jc digit2

    mul ebx
    jc digit3

    mul ebx
    jc digit4

    mul ebx
    jc digit5

    mov eax,edi             ;retrieve lower 5 digits
    mul ecx                 ;div 10000
jc digit6

    mul ebx                 ;multiply by 10 to get next digit in edx
    jc digit7

    mul ebx                 ;3rd digit
    jc digit8

    mul ebx                 ;4th digit
    jc digit9

    mul ebx                 ;5th digit
    jmp digit10

    ;###############end part1

digit1:
    add edx,30h             ;top digit is left in edx, convert to ascii
    mov [esi],dl            ;store top digit

    mul ebx                 ;multiply by 10 to get next digit into edx
    inc esi
digit2:
    add edx,30h             ;convert to ascii
    mov [esi],dl            ;and store

    mul ebx
    inc esi
digit3:
    add edx,30h             ;convert to ascii
    mov [esi],dl            ;and store

    mul ebx
    inc esi
digit4:
    add edx,30h             ;convert to ascii
    mov [esi],dl            ;and store

    mul ebx
    inc esi
digit5:
    add edx,30h             ;convert to ascii
    mov [esi],dl            ;and store

    mov eax,edi             ;retrieve lower 5 digits
    mul ecx
    inc esi                 ;div 10000
digit6:
    add edx,30h             ;convert 1st digit to ascii
    mov [esi],dl            ;and store

    mul ebx                 ;multiply by 10 to get next digit in edx
    inc esi
digit7:
    add edx,30h             ;convert to ascii
    mov [esi],dl            ;and store

    mul ebx                 ;3rd digit
    inc esi
digit8:
    add edx,30h
    mov [esi],dl

    mul ebx                 ;4th digit
    inc esi
digit9:
    add edx,30h
    mov [esi],dl

    mul ebx                 ;5th digit
    inc esi
digit10:
    add edx,30h
    mov [esi],dx            ;last digit, store dx not dl to give a
                            ;zero termination for the result string
    pop edi
    pop esi
    pop ebx
    ret
_dwtoa endp

; #########################################################################

getc proc
    ; Waits for and reads a single character from stdin (no echo).
    
    LOCAL hInput :DWORD
    LOCAL char   :DWORD
    LOCAL bRead  :DWORD

    invoke GetStdHandle,STD_INPUT_HANDLE
    mov hInput,eax

    invoke FlushConsoleInputBuffer,hInput

    invoke SetConsoleMode,hInput,ENABLE_PROCESSED_INPUT

    invoke ReadConsole,hInput,ADDR char,1,ADDR bRead,NULL

    invoke SetConsoleMode,hInput,ENABLE_LINE_INPUT or \
                                 ENABLE_ECHO_INPUT or \
                                 ENABLE_PROCESSED_INPUT
    mov eax,char
    
    ret
getc endp

; #########################################################################
    
end start



